<?php
/*

Plugin Name: Date Filter

Description: Filter posts/products in your website by date range.

Version: 1.1

Author: Biprojit Dey

Author URI: www.linkedin.com/in/biprojit

*/

class Date_Filter_Widget extends WP_Widget {

	function __construct() {
		parent::__construct(
			'Date_Filter_Widget',
			esc_html__( 'Date Filter - by Biprojit Dey', 'text_domain' ),
			array( 'description' => esc_html__( 'Filter posts/products in your website by date range', 'text_domain' ), )
		);
	}

	public function widget( $args, $instance ) {
		echo $args['before_widget'];
		if ( ! empty( $instance['title'] ) ) {
			echo $args['before_title'] . apply_filters( 'widget_title', $instance['title'] ) . $args['after_title'];
		}
		echo "<form method='get' action='.'>";
		?>
        
<input type='text' name='from' id="from" style='width:30%;margin-right:1%;' 
value="<?php if( isset($_GET['from']) && $_GET['from'] != '')
	  {
		  echo esc_html($_GET['from']);
	  }
	  else
	  {
	  	  echo esc_html(date("Y-m-d"));
	  } 
	  ?>
">
<input type='text' name='to' id='to' style='width:30%;margin-right:1%;' 
value="<?php if(isset($_GET['to']) && $_GET['to'] != '' )
	  {
		  echo esc_html($_GET['to']);
	  }
	  else
	  {
	  	  echo esc_html(date("Y-m-d"));
	  } 
	  ?>
">
		<input type='submit' name='search' id='search' value='Search' style='width:auto; text-align:center;'>
        <?php
		echo "</form>";
		echo $args['after_widget'];
	}

	public function form( $instance ) {
		$title = ! empty( $instance['title'] ) ? $instance['title'] : esc_html__( 'Search By Date', 'text_domain' );
		?>
		<p>
		<label for="<?php echo esc_attr( $this->get_field_id( 'title' ) ); ?>"><?php esc_attr_e( 'Title:', 'text_domain' ); ?></label> 
		<input class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'title' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'title' ) ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>">
		</p>
		<?php 
	}

	public function update( $new_instance, $old_instance ) {
		$instance = array();
		$instance['title'] = ( ! empty( $new_instance['title'] ) ) ? strip_tags( $new_instance['title'] ) : '';

		return $instance;
	}

}

function register_date_filter_widget() {
    register_widget( 'Date_Filter_Widget' );
}
add_action( 'widgets_init', 'register_date_filter_widget' );

function date_filter_where($where = '') {
	  if( isset($_GET['from']) && $_GET['from'] != '' && isset($_GET['to']) && $_GET['to'] != '' )
	  {
		  	$filtered_date_filter_from = sanitize_text_field( $_GET['from'], false );
		  	$filtered_date_filter_to = sanitize_text_field( $_GET['to'], false );			
    $where .= " AND post_date >= '" . date('Y-m-d', strtotime($filtered_date_filter_from)). " 00:00:00' AND post_date <= '" . date('Y-m-d', strtotime($filtered_date_filter_to)) . " 23:59:59'";
	  }
    return $where;
  }
 
add_filter('posts_where', 'date_filter_where');
$recent = new WP_Query($args);